unit IniTools;

interface



function  IniReadBool(const FileName, Section, Ident: string; Default: Boolean): Boolean;
function  IniReadInteger(const FileName, Section, Ident: string; Default: Integer): Integer;
function  IniReadString(const FileName, Section, Ident, Default: string): string;
procedure IniWriteBool(const FileName, Section, Ident: string; Value: Boolean);
procedure IniWriteInteger(const FileName, Section, Ident: string; Value: Integer);
procedure IniWriteString(const FileName, Section, Ident, Value: string);

implementation
uses
  IniFiles;

function IniReadBool(const FileName, Section, Ident: string; Default: Boolean): Boolean;
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(FileName);
  try
    Result := Ini.ReadBool(Section, Ident, Default);
  finally
    Ini.Free;
  end;
end;


function IniReadInteger(const FileName, Section, Ident: string; Default: Integer): Integer;
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(FileName);
  try
    Result := Ini.ReadInteger(Section, Ident,Default);
  finally
    Ini.Free;
  end;
end;

function IniReadString(const FileName, Section, Ident, Default: string): string;
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(FileName);
  try
    Result := Ini.ReadString(Section, Ident,Default);
  finally
    Ini.Free;
  end;
end;


procedure IniWriteBool(const FileName, Section, Ident: string; Value: Boolean);
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(FileName);
  try
    Ini.WriteBool(Section, Ident, Value);
  finally
    Ini.Free;
  end;
end;


procedure IniWriteInteger(const FileName, Section, Ident: string; Value: Integer);
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(FileName);
  try
    Ini.WriteInteger(Section, Ident, Value);
  finally
    Ini.Free;
  end;
end;

procedure IniWriteString(const FileName, Section, Ident, Value: string);
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(FileName);
  try
    Ini.WriteString(Section, Ident, Value);
  finally
    Ini.Free;
  end;
end;

end.
