unit Mu;
 
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, ComCtrls, ShellCtrls, Grids,  {Outline,    }
  DirOutln, Menus, SynEditHighlighter, SynHighlighterPas, SynEdit,
  SynAutoCorrect, uPSComponent;
type
  TForm1 = class(TForm)
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    Memo1: TMemo;
    PopupMenu1: TPopupMenu;
    vsIcon1: TMenuItem;
    List1: TMenuItem;
    Report1: TMenuItem;
    SmallIcon1: TMenuItem;
    SynPasSyn1: TSynPasSyn;
    SynEditor: TSynEdit;
    PopupMenu2: TPopupMenu;
    Open1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Save1: TMenuItem;
    PSScript1: TPSScript;
    DebugMemo: TMemo;
    Compile1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    UmbenennButton: TButton;
    Button2: TButton;
    procedure FileListBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Compile1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure UmbenennButtonClick(Sender: TObject);
    procedure SynEditorChange(Sender: TObject);
    procedure PSScript1Compile(Sender: TPSScript);
  private
    { Private-Deklarationen }
    Compiled : boolean;
    Procedure SelectLine(line : Integer);
    function ScriptFilter(InStr:String; nr:integer):String;
    function   IniFileName :string;
    procedure CompileScript;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  FileNummer : integer;
implementation

{$R *.dfm}
uses IniTools,uPSUtils,uPSRuntime;


procedure TForm1.FileListBox1Change(Sender: TObject);
var i,c:integer;
begin
    c:= FileListBox1.Count;
    i:=0;
    Memo1.Clear;
    while i < c do
    begin

        Memo1.Lines.Add(ScriptFilter(FileListBox1.Items[i],i));
        inc(i);
    end;
end;


procedure TForm1.FormCreate(Sender: TObject);
Var ScriptFile: String;
begin
 Compiled:= false;
 DirectoryListBox1.Directory:= IniReadString(IniFileName,'Start', 'Dir', '');
 ScriptFile := IniReadString(IniFileName,'Filter','ScriptFile',ExtractFilePath(ParamStr(0))+'\Scripts\DavorSetzer.pas')  ;
 OpenDialog1.InitialDir:=ExtractFilePath(ScriptFile);
 SaveDialog1.InitialDir :=  OpenDialog1.InitialDir  ;
 if ScriptFile<>'' then
 begin
      SynEditor.Lines.LoadFromFile(ScriptFile);
      CompileScript;
 end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    IniWriteString(IniFileName,'Start', 'Dir',DirectoryListBox1.Directory);
end;

procedure TForm1.Open1Click(Sender: TObject);
Var ScriptFile : String;
begin
   if OpenDialog1.Execute then
   begin
     ScriptFile :=   OpenDialog1.FileName;
     SynEditor.Lines.LoadFromFile(ScriptFile);
     IniWriteString(IniFileName,'Filter','ScriptFile',ScriptFile);
     CompileScript;
     FileListBox1.Update;
   end;
end;

procedure TForm1.Save1Click(Sender: TObject);
Var ScriptFile : String;
begin
   if SaveDialog1.Execute then
   begin
     ScriptFile :=  SaveDialog1.FileName ;
     SynEditor.Lines.SaveToFile( ScriptFile);
     IniWriteString(IniFileName,'Filter','ScriptFile',ScriptFile);
   end;
end;

function TForm1.ScriptFilter(InStr: String; nr:integer): String;
begin
 // Script funktion aufrufen
    if not Compiled then exit;
    PSScript1.SetPointerToData('FileNummer', @FileNummer, PSScript1.FindBaseType(bts32));
    try
        FileNummer := nr;
        result := PSScript1.ExecuteFunction([instr],'filter');
    except
        Compiled := false;
        result := '';
        DebugMemo.Lines.Add(PSScript1.ExecErrorToString);
    end;
end;

procedure TForm1.Compile1Click(Sender: TObject);
begin
    CompileScript;
    FileListBox1.Update;
end;

procedure TForm1.SelectLine(line: Integer);
var
   J,SkipChars: Integer;
begin
      SkipChars := 0;
      for J := 0 to line -2 do
         Skipchars := SkipChars + Length(SynEditor.Lines[J]) + 2;
      Skipchars := SkipChars +  1;
      SynEditor.SetFocus;
      SynEditor.SelStart := SkipChars;
      SynEditor.SelEnd := SkipChars + Length(SynEditor.Lines[line-1]);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
    FileListBox1.ScrollWidth        := 600;
    DirectoryListBox1.ScrollWidth   := 300;
end;

function TForm1.IniFileName: string;
begin
   result := ExtractFilePath(ParamStr(0))+'\mu.ini';
end;

procedure TForm1.UmbenennButtonClick(Sender: TObject);
Var i: integer;
    s: String;
begin
        CompileScript;
        for i := 0 to (FileListBox1.Items.Count - 1) do begin
            try
                s := ScriptFilter(FileListBox1.Items[i],i);
                if s <> '' then
                    if FileListBox1.Items[i] <> s then
                        RenameFile(FileListBox1.Items[i], s) ;
            finally
            end;
        end;
        FileListBox1.Update;
end;

procedure TForm1.SynEditorChange(Sender: TObject);
begin
 DebugMemo.Clear;
 Memo1.Clear;
 UmbenennButton.Enabled:= False;
end;

procedure TForm1.CompileScript;
var i:integer;
begin
    PSScript1.Script.Assign(SynEditor.Lines);
    DebugMemo.Clear;
    if PSScript1.Compile then
    begin
        DebugMemo.Lines.Add('Succesfull Compiled');
        Compiled := true;
        UmbenennButton.Enabled:=true;
    end
    else
    begin
          DebugMemo.Lines.Add('Compiler Error!');
          UmbenennButton.Enabled:=false;
          for i := 0 to  PSScript1.CompilerMessageCount -1 do
          begin
              DebugMemo.Lines.Add(PSScript1.CompilerMessages[i].MessageToString) ;
              SelectLine(PSScript1.CompilerMessages[i].Row);
              exit;    // will nur den ersten fehler sehen
         end;
    end;
end;

procedure TForm1.PSScript1Compile(Sender: TPSScript);
begin
      PSScript1.AddRegisteredPTRVariable('FileNummer', 'integer');
end;

end.
